unit PickerUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, RzPanel, StdCtrls, RzLabel, ImgList, MMSystem, ClipBrd;

type
  TPickerForm = class(TForm)
    RzPanel1: TRzPanel;
    Image: TImage;
    Timer: TTimer;
    ColorLabel: TRzLabel;
    Cross: TImageList;
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PickerForm: TPickerForm;

implementation

uses FloatUnit;

{$R *.dfm}

procedure TPickerForm.ImageMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var Ratio, GrabLeft, GrabTop, GrabWidth, GrabHeight: Integer;
    DCDesk: HDC;
    Current: Cardinal;
    R, G, B: Byte;
begin
  Left := Left + X - (ClientWidth div 2);
  Top := Top + Y - (ClientWidth div 2);

  try
    DCDesk := GetWindowDC(GetDesktopWindow);
    Current := GetPixel(DCDesk, Mouse.CursorPos.X, Mouse.CursorPos.Y);
    B := Byte(Current and $00FF0000 shr 16);
    G := Byte(Current and $0000FF00 shr 8);
    R := Current and $000000FF;
    ColorLabel.Font.Color := Current;
    ColorLabel.ShadowColor := clWhite xor Current;
    ColorLabel.Caption := '#' + IntToHex(R, 2) + IntToHex(G, 2) + IntToHex(B, 2);
  except  end;

  Ratio := 4;
  GrabWidth := Image.Width div Ratio;
  GrabHeight := Image.Height div Ratio;

  GrabLeft := Mouse.CursorPos.X - GrabWidth div 2;
  GrabTop := Mouse.CursorPos.Y - GrabHeight div 2;

  try
    DCDesk := GetWindowDC(GetDesktopWindow);
    //AlphaBlendValue := 0;
    StretchBlt(Image.Canvas.Handle, 0, 0, GrabWidth * Ratio, GrabHeight * Ratio, DCDesk, GrabLeft, GrabTop, GrabWidth, GrabHeight, SRCCOPY);
    ReleaseDC (GetDesktopWindow, DCDesk);
    Cross.Draw(Image.Canvas, Image.Width div 2 - 8, Image.Height div 2 - 8, 0);
    //AlphaBlendValue := 255;
    Image.Refresh;
  except end;
end;

procedure TPickerForm.TimerTimer(Sender: TObject);
var Ratio, GrabLeft, GrabTop, GrabWidth, GrabHeight: Integer;
    DCDesk: HDC;
    Current: Cardinal;
    R, G, B: Byte;
begin
  if not Visible then
    Exit;
  if (Mouse.CursorPos.X < Left) or (Mouse.CursorPos.X > Left + ClientWidth) or (Mouse.CursorPos.Y < Top) or (Mouse.CursorPos.Y > Top + ClientWidth) then
   begin
     Left := Mouse.CursorPos.X - (ClientWidth div 2);
     Top := Mouse.CursorPos.Y - (ClientWidth div 2);
   end;
  //Exit;
 try
    DCDesk := GetWindowDC(GetDesktopWindow);
    Current := GetPixel(DCDesk, Mouse.CursorPos.X, Mouse.CursorPos.Y);
    B := Byte(Current and $00FF0000 shr 16);
    G := Byte(Current and $0000FF00 shr 8);
    R := Current and $000000FF;
    ColorLabel.Font.Color := Current;
    ColorLabel.ShadowColor := clWhite xor Current;
    ColorLabel.Caption := '#' + IntToHex(R, 2) + IntToHex(G, 2) + IntToHex(B, 2);
  except  end;

  Ratio := 4;
  GrabWidth := Image.Width div Ratio;
  GrabHeight := Image.Height div Ratio;

  GrabLeft := Mouse.CursorPos.X - GrabWidth div 2;
  GrabTop := Mouse.CursorPos.Y - GrabHeight div 2;

  try
    DCDesk := GetWindowDC(GetDesktopWindow);
    //AlphaBlendValue := 0;
    StretchBlt(Image.Canvas.Handle, 0, 0, GrabWidth * Ratio, GrabHeight * Ratio, DCDesk, GrabLeft, GrabTop, GrabWidth, GrabHeight, SRCCOPY);
    ReleaseDC (GetDesktopWindow, DCDesk);
    Cross.Draw(Image.Canvas, Image.Width div 2 - 8, Image.Height div 2 - 8, 0);
    //AlphaBlendValue := 255;
    Image.Refresh;
  except end;
end;

procedure TPickerForm.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;
end;

procedure TPickerForm.FormShow(Sender: TObject);
begin
  FloatForm.Hide;
end;

procedure TPickerForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FloatForm.Show;
end;

procedure TPickerForm.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
   begin
     Clipboard.AsText := ColorLabel.Caption;
     FloatForm.PlayResSound('SOUND1',SND_ASYNC);
   end;
  Close;
end;

end.
